Ubuntu 14.04でUnicornとNginxを使用してRailsアプリをデプロイする方法

前書き

Ruby on Railsアプリケーションをデプロイする準備ができたら、考慮すべき多くの有効なセットアップがあります。 このチュートリアルは、Ubuntu 14.04でUnicornとNginxを使用して、PostgreSQLをデータベースとして使用して、Ruby on Railsアプリケーションの運用環境を展開するのに役立ちます。

Unicornはhttps://www.digitalocean.com/community/tutorials/how-to-deploy-a-rails-app-with-passenger-and-nginx-on-ubuntu-14-04[Passenger]のようなアプリケーションサーバーです。 ]またはhttps://www.digitalocean.com/community/tutorials/how-to-deploy-a-rails-app-with-puma-and-nginx-on-ubuntu-14-04[Puma]は、リクエストを同時に処理するRailsアプリケーション。 Unicornはユーザーが直接アクセスするようには設計されていないため、ユーザーとRailsアプリケーション間のリクエストとレスポンスをバッファリングするリバースプロキシとしてNginxを使用します。

前提条件

このチュートリアルでは、アプリケーションをデプロイするユーザーに、次のソフトウェアがインストールされたUbuntu 14.04サーバーがあることを前提としています。

まだセットアップしていない場合は、上記にリンクされているチュートリアルに従ってください。 ユーザーは* deploy *と呼ばれると仮定します。

また、このチュートリアルでは、開発環境またはテスト環境のセットアップ方法については説明しません。 それに関するヘルプが必要な場合は、PostgreSQL with Railsチュートリアルの例を参照してください。

Railsアプリケーションを作成する

理想的には、デプロイしたいRailsアプリケーションがすでに存在します。 この場合、このセクションをスキップして、適切な置換を行ってください。 そうでない場合、最初のステップは、PostgreSQLをデータベースとして使用する新しいRailsアプリケーションを作成することです。

このコマンドは、PostgreSQLをデータベースとして使用する「appname」という名前の新しいRailsアプリケーションを作成します。 強調表示された「アプリ名」を別のものに置き換えてください。

rails new  -d postgresql

次に、アプリケーションディレクトリに移動します。

cd

Railsアプリケーションの本番環境で使用されるPostgreSQLユーザーを作成してみましょう。

実稼働データベースユーザーの作成

物事を簡単にするために、運用データベースユーザーにアプリケーション名と同じ名前を付けましょう。 たとえば、アプリケーションの名前が「appname」の場合、次のようなPostgreSQLユーザーを作成する必要があります。

sudo -u postgres createuser -s

データベースユーザーのパスワードを設定したいので、次のようにPostgreSQLコンソールを入力します。

sudo -u postgres psql

次に、データベースユーザーのパスワード(この例では「appname」)を次のように設定します。

\password

希望のパスワードを入力して確認します。

次のコマンドでPostgreSQLコンソールを終了します。

\q

これで、適切なデータベース接続情報を使用してアプリケーションを構成する準備が整いました。

データベース接続の構成

アプリケーションのルートディレクトリ( + cd〜/ +)にいることを確認します。

お気に入りのテキストエディターでアプリケーションのデータベース構成ファイルを開きます。 viを使用します。

vi config/database.yml

「+ default +」セクションの下で、「pool:5」という行を見つけて、その下に次の行を追加します(まだ存在しない場合)。

 host: localhost

ファイルの一番下までスクロールすると、 `+ production`セクションが次のように設定されていることがわかります。

 username:
 password: <%= ENV['_DATABASE_PASSWORD'] %>

本番ユーザー名が以前に作成したデータベースユーザーと一致しない場合は、ここで設定します。

データベースのパスワードは、環境変数 `+ _DATABASE_PASSWORD +`によって読み取られるように設定されていることに注意してください。 Gitなどの分散バージョン管理システムを使用している場合は簡単に公開される可能性があるため、本番用のパスワードとシークレットをアプリケーションコードベースの外部に保管することをお勧めします。 次に、環境変数を使用してデータベース認証を設定する方法について説明します。

rbenv-varsプラグインをインストールする

実動Railsアプリケーションをデプロイする前に、環境変数を使用して実動秘密鍵とデータベースパスワードを設定する必要があります。 実行時にパスワードとシークレットをアプリケーションに読み込むために使用できる環境変数を管理する簡単な方法は、* rbenv-vars *プラグインを使用することです。

rbenv-varsプラグインをインストールするには、単純に `+ .rbenv / plugins +`ディレクトリに移動し、GitHubから複製します。 たとえば、rbenvがホームディレクトリにインストールされている場合、次のコマンドを実行します。

cd ~/.rbenv/plugins
git clone https://github.com/sstephenson/rbenv-vars.git

環境変数を設定する

rbenv-varsプラグインがインストールされたので、必要な環境変数を設定しましょう。

最初に、署名されたCookieの整合性を検証するために使用される秘密鍵を生成します。

cd ~/appname
rake secret

生成された秘密鍵をコピーしてから、お気に入りのエディターで `+ .rbenv-vars +`ファイルを開きます。 viを使用します。

vi .rbenv-vars

ここで設定した環境変数は、Railsアプリケーションで読み取ることができます。

最初に、 `+ SECRET_KEY_BASE +`変数を次のように設定します(強調表示されたテキストを、生成およびコピーしたばかりのシークレットに置き換えます):

SECRET_KEY_BASE=

次に、 `+ _DATABASE_PASSWORD +`変数を次のように設定します(強調表示された「APPNAME」をアプリケーション名に、「prod_db_pass」を本番データベースのユーザーパスワードに置き換えます):

_DATABASE_PASSWORD=

保存して終了。

次のコマンドを実行すると、rbenv-varsプラグインを使用して、アプリケーションに設定されている環境変数を表示できます。

rbenv vars

シークレットパスワードまたはデータベースパスワードを変更する場合は、 `+ .rbenv-vars +`ファイルを更新します。 このファイルを非公開にして、公開コードリポジトリを含めないように注意してください。

本番データベースを作成する

アプリケーションがPostgreSQLデータベースと通信するように構成されたので、実稼働データベースを作成しましょう。

RAILS_ENV=production rake db:create

コントローラーを生成する

例に沿ってフォローしている場合は、scaffoldコントローラーを生成して、アプリケーションに何かを見てもらいます。

rails generate scaffold Task title:string note:text

次のコマンドを実行して、運用データベースを更新します。

RAILS_ENV=production rake db:migrate

アセットのプリコンパイル

この時点で、アプリケーションは動作するはずですが、画像、CSS、およびスクリプトがロードされるように、アセットをプリコンパイルする必要があります。 これを行うには、次のコマンドを実行します。

RAILS_ENV=production rake assets:precompile

テストアプリケーション

アプリケーションが機能するかどうかをテストするには、実稼働環境を実行し、サーバーのパブリックIPアドレスにバインドします(サーバーのパブリックIPアドレスを置き換えます)。

RAILS_ENV=production rails server --binding=

次に、WebブラウザーでこのURLにアクセスします。

http://:3000/tasks

正常に機能している場合、次のページが表示されます。

image:https://assets.digitalocean.com/articles/rails_unicorn/tasks.png [タスクコントローラー]

Railsサーバーに戻り、 `+ Ctrl-c +`を押してアプリケーションを停止します。

Unicornをインストールする

これで、Unicornをインストールする準備が整いました。

これを行う簡単な方法は、アプリケーションの `+ Gemfile +`に追加することです。 お気に入りのエディターでGemfileを開きます(アプリケーションのルートディレクトリにいることを確認してください)。

vi Gemfile

ファイルの最後に、次の行でUnicorn gemを追加します。

gem 'unicorn'

保存して終了。

Unicornおよび未解決の依存関係をインストールするには、Bundlerを実行します。

bundle

Unicornがインストールされましたが、構成する必要があります。

Unicornを構成する

Unicorn設定を `+ config / unicorn.rb +`に追加しましょう。 テキストエディターでファイルを開きます。

vi config/unicorn.rb

この構成をコピーしてファイルに貼り付けます。

# set path to application
app_dir = File.expand_path("../..", __FILE__)
shared_dir = "#{app_dir}/shared"
working_directory app_dir


# Set unicorn options
worker_processes 2
preload_app true
timeout 30

# Set up socket location
listen "#{shared_dir}/sockets/unicorn.sock", :backlog => 64

# Logging
stderr_path "#{shared_dir}/log/unicorn.stderr.log"
stdout_path "#{shared_dir}/log/unicorn.stdout.log"

# Set master PID location
pid "#{shared_dir}/pids/unicorn.pid"

保存して終了。 これにより、アプリケーションの場所、およびソケット、ログ、およびPIDの場所でUnicornが構成されます。 ファイルを自由に変更するか、必要な他のオプションを追加してください。

次に、構成ファイルで参照されたディレクトリを作成します。

mkdir -p shared/pids shared/sockets shared/log

Unicorn Initスクリプトを作成する

初期化スクリプトを作成して、Unicornを簡単に起動および停止し、起動時に起動するようにします。

スクリプトを作成し、このコマンドを使用して編集用に開きます(必要に応じて、強調表示されている部分をアプリケーション名に置き換えます)。

sudo vi /etc/init.d/unicorn_

次のコードブロックをコピーして貼り付け、必ず「+ USER n」と「+ APP_NAME」(強調表示)を適切な値に置き換えてください。

#!/bin/sh

### BEGIN INIT INFO
# Provides:          unicorn
# Required-Start:    $all
# Required-Stop:     $all
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: starts the unicorn app server
# Description:       starts unicorn using start-stop-daemon
### END INIT INFO

set -e

USAGE="Usage: $0 <start|stop|restart|upgrade|rotate|force-stop>"

# app settings
USER=""
APP_NAME=""
APP_ROOT="/home/$USER/$APP_NAME"
ENV="production"

# environment settings
PATH="/home/$USER/.rbenv/shims:/home/$USER/.rbenv/bin:$PATH"
CMD="cd $APP_ROOT && bundle exec unicorn -c config/unicorn.rb -E $ENV -D"
PID="$APP_ROOT/shared/pids/unicorn.pid"
OLD_PID="$PID.oldbin"

# make sure the app exists
cd $APP_ROOT || exit 1

sig () {
 test -s "$PID" && kill -$1 `cat $PID`
}

oldsig () {
 test -s $OLD_PID && kill -$1 `cat $OLD_PID`
}

case $1 in
 start)
   sig 0 && echo >&2 "Already running" && exit 0
   echo "Starting $APP_NAME"
   su - $USER -c "$CMD"
   ;;
 stop)
   echo "Stopping $APP_NAME"
   sig QUIT && exit 0
   echo >&2 "Not running"
   ;;
 force-stop)
   echo "Force stopping $APP_NAME"
   sig TERM && exit 0
   echo >&2 "Not running"
   ;;
 restart|reload|upgrade)
   sig USR2 && echo "reloaded $APP_NAME" && exit 0
   echo >&2 "Couldn't reload, starting '$CMD' instead"
   $CMD
   ;;
 rotate)
   sig USR1 && echo rotated logs OK && exit 0
   echo >&2 "Couldn't rotate logs" && exit 1
   ;;
 *)
   echo >&2 $USAGE
   exit 1
   ;;
esac

保存して終了。 これにより、 `+ service unicorn_ +`を使用してUnicornとRailsアプリケーションを起動および停止できます。

スクリプトの権限を更新し、起動時にUnicornを起動できるようにします。

sudo chmod 755 /etc/init.d/unicorn_appname
sudo update-rc.d unicorn_appname defaults

今すぐ始めましょう:

sudo service unicorn_ start

これで、Railsアプリケーションの実稼働環境がUnicornの下で実行され、 `+ shared / sockets / unicorn.socks`ソケットをリッスンしています。 外部ユーザーがアプリケーションにアクセスできるようにするには、Nginxリバースプロキシを設定する必要があります。

Nginxのインストールと構成

apt-getを使用してNginxをインストールします。

sudo apt-get install nginx

次に、デフォルトのサーバーブロックをテキストエディターで開きます。

sudo vi /etc/nginx/sites-available/default

ファイルの内容を次のコードブロックに置き換えます。 強調表示された部分を適切なユーザー名とアプリケーション名に置き換えてください。

upstream app {
   # Path to Unicorn SOCK file, as defined previously
   server unix:/home///shared/sockets/unicorn.sock fail_timeout=0;
}

server {
   listen 80;
   server_name localhost;

   root /home///public;

   try_files $uri/index.html $uri @app;

   location @app {
       proxy_pass http://app;
       proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
       proxy_set_header Host $http_host;
       proxy_redirect off;
   }

   error_page 500 502 503 504 /500.html;
   client_max_body_size 4G;
   keepalive_timeout 10;
}

保存して終了。 これにより、Nginxがリバースプロキシとして構成され、HTTPリクエストがUnixソケットを介してUnicornアプリケーションサーバーに転送されます。 必要に応じて自由に変更を加えてください。

Nginxを再起動して、変更を有効にします。

sudo service nginx restart

これで、サーバーのパブリックIPアドレスまたはFQDNを介してRailsアプリケーションの運用環境にアクセスできます。 前に作成したタスクコントローラーにアクセスするには、Webブラウザーでアプリケーションサーバーにアクセスします。

http:///tasks

アプリケーションを初めてテストしたときと同じページが表示されるはずですが、現在はNginxとUnicornを介して提供されています。

結論

おめでとうございます。 NginxとUnicornを使用して、Ruby on Railsアプリケーションの運用環境を展開しました。

実動Railsアプリケーションのデプロイメントを改善したい場合は、https://www.digitalocean.com/community/tutorial_series/how-to-use-capistrano-to-automate-deployments [How To]のチュートリアルシリーズを確認してください。 Capistranoを使用して展開を自動化する]。 このシリーズはCentOSに基づいていますが、それでもデプロイメントの自動化に役立つはずです。

前の投稿:Ubuntu 16.04でDocker Swarmを使用してOpenFaaSをインストールして保護する方法
次の投稿:Ruby on Railsアプリケーションのネストされたリソースを作成する方法